/*============================================================================
//	apci31as.h
//
//	aPCI-P31A
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//	̿ɂׯ߰֐̎gpႪLqĂ܂B
//
//==========================================================================*/
#pragma once

#include <windows.h>
#include "Apci31aw.h"

using namespace System;
using namespace System::ComponentModel;
using namespace System::Collections;
using namespace System::Windows::Forms;
using namespace System::Data;
using namespace System::Drawing;


namespace SampleP31a
{
	/// <summary> 
	/// Apci31as ̊Tv
	///
	/// x : ̃NX̖OύXꍇÃNXˑ邷ׂĂ .resx t@CɊ֘Atꂽ 
	///          }l[W \[X RpC c[ɑ΂ 'Resource File Name' vpeB 
	///          ύXKv܂B̕ύXsȂƁA
	///          fUCiƁÃtH[Ɋ֘Atꂽ[JCYς݃\[XƂA
	///          ݂ɗpłȂȂ܂B
	/// </summary>
	public __gc class Apci31as : public System::Windows::Forms::Form
	{
	public: 
		Apci31as(void)
		{
			InitializeComponent();
		}
        
	protected: 
		void Dispose(Boolean disposing)
		{
			if (disposing && components)
			{
				components->Dispose();
			}
			__super::Dispose(disposing);
		}
        
	private:
		/// <summary>
		/// KvȃfUCiϐłB
		/// </summary>
		System::ComponentModel::Container* components;

		static Apci31aw* P31aw;

		/// <summary>
		/// fUCi T|[gɕKvȃ\bhłB̃\bh̓e
		/// R[h GfB^ŕύXȂłB
		/// </summary>
		void InitializeComponent(void)
		{
			// 
			// Apci31as
			// 
			this->AutoScaleBaseSize = System::Drawing::Size(5, 12);
			this->ClientSize = System::Drawing::Size(292, 266);
			this->Name = S"Apci31as";
			this->StartPosition = System::Windows::Forms::FormStartPosition::CenterScreen;
			this->Text = S"aPCI-P31A Sample";
			this->Load += new System::EventHandler(this, Apci31as_Load);

		}		
		private: System::Void Apci31as_Load(System::Object *  sender, System::EventArgs *  e)
		{
			short wLogSlot;				/* ޲̘_ۯĔԍi[ */
			Apci31aw::Resource* ri;		/* ؿ */
			int dwDllVer, dwDrvVer;
			int dwSwVal;				/* ۰ذ̒l */
			Byte cbDat;
			bool bResult;				/*  */
			String* szBuf;
			int i;

			P31aw = new Apci31aw;
			ri   = new Apci31aw::Resource;
			ri->dwMemBase		= new Int32[Apci31aw::MAX_MEM];
			ri->dwMemLength		= new Int32[Apci31aw::MAX_MEM];
			ri->dwMemAttrib		= new Int32[Apci31aw::MAX_MEM];
			ri->dwIOPortBase	= new Int32[Apci31aw::MAX_IO];
			ri->dwIOPortLength	= new Int32[Apci31aw::MAX_IO];
			ri->dwIRQRegisters	= new Int32[Apci31aw::MAX_IRQ];
			ri->dwIRQAttrib		= new Int32[Apci31aw::MAX_IRQ];
			ri->dwDMALst		= new Int32[Apci31aw::MAX_DMA];
			ri->dwDMAAttrib		= new Int32[Apci31aw::MAX_DMA];
			ri->dwReserved1		= new Int32[Apci31aw::MAX_RSV];

			// 
			ri->dwNumMemWindows = 0;
			for (i=0; i<Apci31aw::MAX_MEM; i++) {
				ri->dwMemBase[i]   = 0;
				ri->dwMemLength[i] = 0;
				ri->dwMemAttrib[i] = 0;
			}
			ri->dwNumIOPorts = 0;
			for (i=0; i<Apci31aw::MAX_IO; i++) {
				ri->dwIOPortBase[i]   = 0;
				ri->dwIOPortLength[i] = 0;
			}
			ri->dwNumIRQs = 0;
			for (i=0; i<Apci31aw::MAX_IRQ; i++) {
				ri->dwIRQRegisters[i] = 0;
				ri->dwIRQAttrib[i]    = 0;
			}
			ri->dwNumDMAs = 0;
			for (i=0; i<Apci31aw::MAX_DMA; i++) {
				ri->dwDMALst[i]    = 0;
				ri->dwDMAAttrib[i] = 0;
			}
			for (i=0; i<Apci31aw::MAX_RSV; i++)
				ri->dwReserved1[i] = 0;

			/*-------------------------------------------------
			// ްޮݔԍ\
			// aPCI-P31A DLL,ײްްޮݔԍ擾
			//-----------------------------------------------*/
			if (P31aw->GetVersion(&dwDllVer, &dwDrvVer) == false) {
				ErrorMessage(Apci31aw::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"Version\n",
									String::Format(S"DLL: 0x{0}\n", dwDllVer.ToString("x8")),
									String::Format(S"DRV: 0x{0}",   dwDrvVer.ToString("x8")));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P31A̎gp錾
			//-----------------------------------------------*/
			wLogSlot = Apci31aw::SLOT_AUTO;			/* gp޲T܂B*/
			bResult = P31aw->Create(&wLogSlot);		/* ꍇA̎޲̘_ۯĔԍi[܂B*/
			if (bResult == false) {					/* ޲܂B*/
				ErrorMessage(Apci31aw::SLOT_AUTO);
				return;
			}
			szBuf = String::Concat(S"Created\n\n",
									String::Format(S"LogSlot: {0}", wLogSlot.ToString("d")));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// ؿ۰ذ̒l擾
			//-----------------------------------------------*/
			if (P31aw->GetResource(wLogSlot, ri) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			if (P31aw->GetSwitchValue(wLogSlot, &dwSwVal) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Resource\n",
									String::Format(S"IO Address: {0}h - {1}h\n",
													ri->dwIOPortBase[0].ToString("x4"),
													(ri->dwIOPortBase[0] + ri->dwIOPortLength[0] - 1).ToString("x4")),
									String::Format(S"Switch    : {0}h", dwSwVal.ToString("x")));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port 1 ɔCӂްo
			//-----------------------------------------------*/
			cbDat = 0xaa;
			if (P31aw->OutPort(wLogSlot, Apci31aw::PORT_1, cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Port 1 փf[^o\n",
									String::Format(S"Port 1 Out Data: {0}h", cbDat.ToString("x")));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// Port 1 ްǂݍ
			//-----------------------------------------------*/
			cbDat = 0x00;
			if (P31aw->InPort(wLogSlot, Apci31aw::PORT_1, &cbDat) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			szBuf = String::Concat(S"Port 1 f[^\n",
									String::Format(S"Port 1 In Data: {0}h", cbDat.ToString("x")));
			ResultMessage(szBuf);
			/*-------------------------------------------------
			// aPCI-P31A̎gpJ
			//-----------------------------------------------*/
			if (P31aw->Close(wLogSlot) == false) {
				ErrorMessage(wLogSlot);
				return;
			}
			ResultMessage(S"Closed");
			this->Close();
		}

		/*============================================================================
		// ʂ\
		//==========================================================================*/
		private: void ResultMessage(String* pszbuf)
		{
			MessageBox::Show(pszbuf, this->Text, 
								MessageBoxButtons::OK, MessageBoxIcon::Information);
		}

		/*============================================================================
		// װүނ\
		//==========================================================================*/
		private: void ErrorMessage(short wLogSlot)
		{
			int dwRes = P31aw->GetLastError(wLogSlot);
			String* szBuf;

			switch (dwRes) {
				case Apci31aw::ERR_SYSTEM:
				case Apci31aw::ERR_WRAPDLL:
					dwRes = System::Runtime::InteropServices::Marshal::GetLastWin32Error();
					szBuf = String::Concat(S"System error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
				default:
					szBuf = String::Concat(S"aPCI-P31A error\n\n",
											String::Format(S"Error code: {0}", 
															dwRes.ToString("x8")));
					break;
			}
			MessageBox::Show(szBuf, S"aPCI-P31A ERROR",
								MessageBoxButtons::OK, MessageBoxIcon::Stop);
		}

	};
}
