Attribute VB_Name = "Wrapper"
'============================================================================
'   apci31aw.bas
'
'   Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
'
'   V1.11 Date 1999/08/23
'
'============================================================================
Option Explicit
Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Declare Function FreeLibrary Lib "kernel32" (ByVal hLibModule As Long) As Long
Declare Function GetProcAddress Lib "kernel32" (ByVal hModule As Long, ByVal lpProcName As String) As Long

Global Const APCI31A_DLL_NAME = "apci31a.dll" ' DLL
Global Const APCI31A_ERR_WRAPDLL = -1         ' ׯ߰֐װ

Dim hDLL As Long                'DLLւ

'============================================================================
'     apci31a.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci31awDllOpen() As Boolean
  Apci31awDllOpen = False
  If hDLL = 0 Then
    hDLL = LoadLibrary(APCI31A_DLL_NAME)
    If hDLL <> 0 Then
      Apci31awDllOpen = Apci31awGetDllExportFunc()
      If Apci31awDllOpen <> True Then
        Apci31awDllClose      ' DLL֐擾ɎŝDLL۰
      End If
    End If
  End If
End Function
'============================================================================
'     apci31a.dll۰(۰ގʹװƂ)
'     
'  ߂l  True
'         s False
'============================================================================
Function Apci31awDllClose() As Boolean
  Apci31awDllClose = False
  If hDLL <> 0 Then
    If FreeLibrary(hDLL) <> 0 Then
      hDLL = 0
      Apci31awDllClose = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P31A DLL,޲ײްްޮݔԍ擾
'     pdwDllVersion    DLLްޮݔԍi[
'         pdwDriverVersion ޲ײްްޮݔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci31awGetVersion(pdwDllVersion As Long, pdwDriverVersion As Long) As Boolean
  Apci31awGetVersion = False
  If hDLL <> 0 Then
    If Apci31aGetVersion(pdwDllVersion, pdwDriverVersion) <> 0 Then
      Apci31awGetVersion = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P31A̔Cӂ޲̎gp錾
'     pwLogSlot  gp޲̘_ۯĔԍi[
'  ߂l  True
'         s False
'============================================================================
Function Apci31awCreate(pwLogSlot As Integer) As Boolean
  Apci31awCreate = False
  If hDLL <> 0 Then
    If Apci31aCreate(pwLogSlot) <> 0 Then
      Apci31awCreate = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P31A̔Cӂ޲̎gpJ
'     wLogSlot ޲̘_ۯĔԍ
'  ߂l  True
'         s False
'============================================================================
Function Apci31awClose(ByVal wLogSlot As Integer) As Boolean
  Apci31awClose = False
  If hDLL <> 0 Then
    If Apci31aClose(wLogSlot) <> 0 Then
      Apci31awClose = True
    End If
  End If
End Function
'============================================================================
'     w޲ؿ擾
'     wLogSlot ؿ擾޲̘_ۯĔԍ
'         pResInfo ؿi[\
'  ߂l  True
'         s False
'============================================================================
Function Apci31awGetResource(ByVal wLogSlot As Integer, pResInfo As APCI31ARESOURCE) As Boolean
  Apci31awGetResource = False
  If hDLL <> 0 Then
    If Apci31aGetResource(wLogSlot, pResInfo) <> 0 Then
      Apci31awGetResource = True
    End If
  End If
End Function
'============================================================================
'     ۰ذ̒l擾
'     wLogSlot       ۰ذ̒l擾޲̘_ۯĔԍ
'         pdwSwitchValue ۰ذ̒li[
'  ߂l  True
'         s False
'============================================================================
Function Apci31awGetSwitchValue(ByVal wLogSlot As Integer, pdwSwitchValue As Long) As Boolean
  Apci31awGetSwitchValue = False
  If hDLL <> 0 Then
    If Apci31aGetSwitchValue(wLogSlot, pdwSwitchValue) <> 0 Then
      Apci31awGetSwitchValue = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăް
'     wLogSlot  ͂޲̘_ۯĔԍ
'         dwLogPort ͂_߰
'         pbInValue ްi[
'  ߂l  True
'         s False
'============================================================================
Function Apci31awInPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, pbInValue As Byte) As Boolean
  Apci31awInPort = False
  If hDLL <> 0 Then
    If Apci31aInPort(wLogSlot, dwLogPort, pbInValue) <> 0 Then
      Apci31awInPort = True
    End If
  End If
End Function
'============================================================================
'     Cӂ߰Ăްo
'     wLogSlot  o͂޲̘_ۯĔԍ
'         dwLogPort o͂_߰
'         bOutValue o͂ް
'  ߂l  True
'         s False
'============================================================================
Function Apci31awOutPort(ByVal wLogSlot As Integer, ByVal dwLogPort As Long, ByVal bOutValue As Byte) As Boolean
  Apci31awOutPort = False
  If hDLL <> 0 Then
    If Apci31aOutPort(wLogSlot, dwLogPort, bOutValue) <> 0 Then
      Apci31awOutPort = True
    End If
  End If
End Function
'============================================================================
'     aPCI-P31A̴װ
'     wLogSlot  װ޲̘_ۯĔԍ
'  ߂l װ
'============================================================================
Function Apci31awGetLastError(ByVal wLogSlot As Integer) As Long
  If hDLL = 0 Then
    Apci31awGetLastError = APCI31A_ERR_WRAPDLL
  Else
    Apci31awGetLastError = Apci31aGetLastError(wLogSlot)
  End If
End Function
'---------------------------------------------------------------------------
'     DLL߰Ċ֐ڽ̎擾
'     
'  ߂l  True
'         s False
'---------------------------------------------------------------------------
Private Function Apci31awGetDllExportFunc() As Boolean
  Dim pFunc As Long
  Apci31awGetDllExportFunc = False
  ' Apci31aGetVersion ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aGetVersion")
  If pFunc = 0 Then Exit Function
  ' Apci31aCreate ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aCreate")
  If pFunc = 0 Then Exit Function
  ' Apci31aClose ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aClose")
  If pFunc = 0 Then Exit Function
  ' Apci31aGetResource ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aGetResource")
  If pFunc = 0 Then Exit Function
  ' Apci31aInPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aInPort")
  If pFunc = 0 Then Exit Function
  ' Apci31aOutPort ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aOutPort")
  If pFunc = 0 Then Exit Function
  ' Apci31aGetLastError ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aGetLastError")
  If pFunc = 0 Then Exit Function
  ' Apci31aGetSwitchValue ̱ڽ擾
  pFunc = GetProcAddress(hDLL, "Apci31aGetSwitchValue")
  If pFunc = 0 Then Exit Function
  Apci31awGetDllExportFunc = True   ' SĂ DLL ߰Ċ֐ڽ擾
End Function


