/*****************************************************************************/
/*	apci31aw.h																 */
/*																			 */
/*	aPCI-P31A															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*	V1.11 Date 1999/08/28													 */
/*																			 */
/*****************************************************************************/

#ifndef __APCI31AW_H__
#define __APCI31AW_H__

#include "apci31a.h"

#ifdef __cplusplus
extern "C"{
#endif

#define APCI31A_DLL_NAME	_T("apci31a.dll")	/* DLL */
#define APCI31A_ERR_WRAPDLL	((DWORD)-1)			/* ׯ߰֐װ */

BOOL Apci31awDllOpen();							/* DLL ۰ */
BOOL Apci31awDllClose();						/* DLL ۰ */
BOOL Apci31awGetVersion(PDWORD pdwDllVersion, PDWORD pdwDriverVersion);	/* aPCI-P31A DLL,ײންޮݔԍ擾 */
BOOL Apci31awCreate(PWORD pwLogSlot);			/* CӂaPCI-P31A̎gp錾 */
BOOL Apci31awClose(WORD wLogSlot);				/* CӂaPCI-P31A̎gpJ */
BOOL Apci31awGetResource(WORD wLogSlot, PAPCI31AR pResInfo);			/* ؿ擾 */
BOOL Apci31awInPort(WORD wLogSlot, DWORD dwLogPort, PBYTE pbInValue);	/* Cӂ߰Ăް */
BOOL Apci31awOutPort(WORD wLogSlot, DWORD dwLogPort, BYTE bOutValue);	/* Cӂ߰Ăްo */
DWORD Apci31awGetLastError(WORD wLogSlot);								/* aPCI-P31A̴װ */
BOOL Apci31awGetSwitchValue(WORD wLogSlot, PDWORD pdwSwitchValue);		/* ۰ذ̒l擾 */

#ifdef __cplusplus
}
#endif

#endif /* __APCI31AW_H__ */
